Foxit PDF RDK

Public Member Functions | Static Public Attributes | List of all members
GraphicsObject Class Reference
Inheritance diagram for GraphicsObject:

## Public Member Functions
| AddClipPath (path, fill_mode)
| Add a path for clipping. More...
| AddClipTextObject (textobject)
| Add text object for clipping. More...
| ClearClips ()
| Clear all clips. More...
| Clone ()
| Clone a new graphics object. More...
| Clone (src_graphicsobjects, dest_graphicsobjects)
| Clone a new graphics object. More...
| GetBlendMode ()
| Get the blend mode for transparent imaging model. More...
| GetClipPath (index)
| Get a path clip by index. More...
| GetClipPathCount ()
| Get the count of path clip. More...
| GetClipPathFillMode (index)
| Get the fill mode of a path clip by index. More...
| GetClipRect ()
| Get clip rectangle. More...
| GetClipTextObject (index)
| Get the text object of a text clip by index. More...
| GetClipTextObjectCount ()
| Get the count of text clip. More...
| GetColorState ()
| Get color state. More...
| GetFillColor ()
| Get the fill color. More...
| GetFillOpacity ()
| Get the opacity value for painting operations other than stroking. More...
| GetFormXObject ()
| Get the form XObject graphics object if current graphics object represents a form XObject object. More...
| GetGraphState ()
| Get graph state. More...
| GetImageObject ()
| Get the image graphics object if current graphics object represents an image object. More...
| GetLayers (layer_tree)
| Get all the layers which are associated with current graphics object. More...
| GetMarkedContent ()
| Get marked content object. More...
| GetMatrix ()
| Get matrix. More...
| GetPathObject ()
| Get the path graphics object if current graphics object represents a path object. More...
| GetRect ()
| Get the rectangle of current graphics object. More...
| GetShadingObject ()
| Get the shading graphics object if current graphics object represents a shading object. More...
| GetStrokeColor ()
| Get the stroke color. More...
| GetStrokeOpacity ()
| Get opacity value for stroke painting operations for paths and glyph outlines. More...
| GetTextObject ()
| Get the text graphics object if current graphics object represents a text object. More...
| GetType ()
| Get the type of current graphics object. More...
| HasTransparency ()
| Check whether current graphics object has transparency or not. More...
| Release ()
| Release a cloned or newly created PDF graphics object which has not been inserted into any PDF page or other object. More...
| RemoveClipPath (index)
| Remove a path clip by index. More...
| RemoveClipTextObject (index)
| Remove a text clip by index for clipping. More...
| Rotate (angle)
| Rotate current graphics object from current state with specified angle degree in clockwise. More...
| SetBlendMode (blend_mode)
| Set the blend mode for transparent imaging model. More...
| SetClipRect (clip_rect)
| Set clip rectangle. More...
| SetColorState (color_state)
| Set color state. More...
| SetFillColor (color)
| Set the fill color. More...
| SetFillOpacity (opacity)
| Set the opacity value for painting operations other than stroking. More...
| SetGraphState (graph_state)
| Set graph state. More...
| SetMatrix (matrix)
| Set matrix. More...
| SetStrokeColor (color)
| Set the stroke color. More...
| SetStrokeOpacity (opacity)
| Set opacity value for stroke painting operations for paths and glyph outlines. More...
| Transform (matrix, need_transform_clippath)
| Transform current graphics object. More...
Public Member Functions inherited from NativeObjectWrapper
| constructor (r)
| GetPointerAsNumber ()

## Static Public Attributes
static | e_BlendColor
| Creates a color with the hue and saturation of the source color, and the luminosity of the backdrop color. More...
static | e_BlendColorBurn
| Darkens backdrop color to reflect the source color. More...
static | e_BlendColorDodge
| Brightens backdrop color to reflect source colors. More...
static | e_BlendDarken
| Select darker one of backdrop and source colors. More...
static | e_BlendDifference
| Subtracts the darker of the two constituent colors from lighter colors. More...
static | e_BlendExclusion
| Creates a color with the hue of the source color, and the saturation and luminosity of the backdrop color. More...
static | e_BlendHardlight
| Multiply or screens colors, depending on source color value. More...
static | e_BlendHue
| Creates a color with the hue of the source color, and the saturation and luminosity of the backdrop color. More...
static | e_BlendLighten
| Select lighter one of backdrop and source colors. More...
static | e_BlendLuminosity
| Creates a color with the luminosity of the source color, and the hue and saturation of the backdrop color. More...
static | e_BlendMultiply
| Multiply backdrop by source color values. More...
static | e_BlendNormal
| Enumeration for render blend mode. More...
static | e_BlendOverlay
| Multiply or screens colors, depending on backdrop color value. More...
static | e_BlendSaturation
| Creates a color with the saturation of the source color, and the hue and luminosity of the backdrop color. More...
static | e_BlendScreen
| Multiply complements of backdrop by source color values, and then complement the result. More...
static | e_BlendSoftlight
| Darkens or lightens colors, depending on source color value. More...
static | e_TypeAll
| Enumeration for PDF graphics object type. More...
static | e_TypeFormXObject
| Form XObject graphics object.
static | e_TypeImage
| Image graphics object.
static | e_TypePath
| Path graphics object.
static | e_TypeShading
| Shading graphics object.
static | e_TypeText
| Text graphics object.

## Detailed Description

Content of a PDF page usually consists of a sequence of graphics objects. Each graphics object contains its state information, data and instructions for rendering.
Class GraphicsObject is the base class for all types of PDF graphics objects. It offers the base functions to get/set graphics object's common properties. For concrete graphics object types, please refer to derived classes.
To get or insert/remove a graphics object, please refer to class GraphicsObjects.
If any change is done to a PDF graphics object, please remember to call function GraphicsObjects.GenerateContent for GraphicsObjects object (to which current graphics object belongs). Please refer to comment of function GraphicsObjects.GenerateContent for more details.

See also
  GraphicsObjects

Examples
  /Users/ec2-user/gitlab-runner/builds/E-xKdhDo/0/foxit/sdk/mobile/gsdk-doc-auto-build/harmony_nodejs/input/Index.js.

## Member Function Documentation

## ◆ AddClipPath()

GraphicsObject.AddClipPath | ( | path | ,
|  | fill_mode |
| ) |  |

Add a path for clipping.

Parameters

  [in] | path | Path data to be added to current graphics object.
  [in] | fill_mode | Fill mode for the input path. Please refer to values starting from e_FillModeNone and this should be one of these values.

Returns
  true means success, while false means failure.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ AddClipTextObject()

GraphicsObject.AddClipTextObject | ( | textobject |  | ) |

Add text object for clipping.

Parameters

  [in] | textobject | Text object to be added for clipping.

Returns
  true means success, while false means failure.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ ClearClips()

GraphicsObject.ClearClips | ( |  | ) |

Clear all clips.

Returns
  true means success, while false means failure.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ Clone() [1/2]

GraphicsObject.Clone | ( |  | ) |

Clone a new graphics object.

Newly cloned graphics object is related to the same page with current graphics object by default. Newly cloned graphics object can only be used inside the PDF file which contains current graphics object. If the cloned graphics object is not inserted to any PDF page or other object, please remember to call function GraphicsObject.Release to release it when not use it any more.

Returns
  Cloned graphics object. If there is any error, this function will return null.

## ◆ Clone() [2/2]

GraphicsObject.Clone | ( | src_graphicsobjects | ,
|  | dest_graphicsobjects |
| ) |  |

Clone a new graphics object.

Newly cloned graphics object is related to the page which is dest_graphicsobjects belong to. Newly cloned graphics object can be used inside or outside the PDF file which contains current graphics object. If the cloned graphics object is not inserted to any PDF page or other object, please remember to call function GraphicsObject.Release to release it when not use it any more.

Returns
  Cloned graphics object. If there is any error, this function will return null.

## ◆ GetBlendMode()

GraphicsObject.GetBlendMode | ( |  | ) |

Get the blend mode for transparent imaging model.

Returns
  The Blend mode for transparent imaging model. Please refer to values starting from GraphicsObject.e_BlendNormal and this would be one of these values.

## ◆ GetClipPath()

GraphicsObject.GetClipPath | ( | index |  | ) |

Get a path clip by index.

Parameters

  [in] | index | Path clip index. Valid range: from 0 to (count-1). count is returned by function GraphicsObject.GetClipPath.

Returns
  Path data. If the return value of function Path.IsEmpty for the returned path object is true, that means there is any error.

## ◆ GetClipPathCount()

GraphicsObject.GetClipPathCount | ( |  | ) |

Get the count of path clip.

Returns
  Count of path clip.

## ◆ GetClipPathFillMode()

GraphicsObject.GetClipPathFillMode | ( | index |  | ) |

Get the fill mode of a path clip by index.

Parameters

  [in] | index | Path clip index. Valid range: from 0 to (count-1). count is returned by function GraphicsObject.GetClipPath.

Returns
  Fill mode. Please refer to values starting from e_FillModeNone and this would be one of these values.

## ◆ GetClipRect()

GraphicsObject.GetClipRect | ( |  | ) |

Get clip rectangle.

Returns
  Clip rectangle. If there is no clip rectangle, a RectF object with all values 0 will be returned.

## ◆ GetClipTextObject()

GraphicsObject.GetClipTextObject | ( | index |  | ) |

Get the text object of a text clip by index.

Parameters

  [in] | index | Text clip index. Valid range: from 0 to (count-1). count is returned by function GraphicsObject.GetClipTextObjectCount.

Returns
  A text graphics object. If there is any error, this function will return null.

## ◆ GetClipTextObjectCount()

GraphicsObject.GetClipTextObjectCount | ( |  | ) |

Get the count of text clip.

Returns
  Count of text clip.

## ◆ GetColorState()

GraphicsObject.GetColorState | ( |  | ) |

Get color state.

Text graphics object, path graphics object, and form XObject graphics object can have color state.

Returns
  Color state.

## ◆ GetFillColor()

GraphicsObject.GetFillColor | ( |  | ) |

Get the fill color.

Text graphics object, path graphics object, and form XObject graphics object can have this property. Function GraphicsObject.GetColorState can be used to get fille color in other color space, like CMYK color space.

Returns
  Color value, in format 0xAARRGGBB.

## ◆ GetFillOpacity()

GraphicsObject.GetFillOpacity | ( |  | ) |

Get the opacity value for painting operations other than stroking.

Returns
  The opacity value. Valid range: 0.0 to 1.0. 0.0 means full transparency and 1.0 means full opaque. If no opacity value can be found, 1 will be returned as default value.

## ◆ GetFormXObject()

GraphicsObject.GetFormXObject | ( |  | ) |

Get the form XObject graphics object if current graphics object represents a form XObject object.

Returns
  Form XObject graphics object. If current graphics object does not represent a form XObject object, this function will return null.

## ◆ GetGraphState()

GraphicsObject.GetGraphState | ( |  | ) |

Get graph state.

Form XObjet graphics object, path graphics object and text graphics object can have this property.

Returns
  Graph state.

## ◆ GetImageObject()

GraphicsObject.GetImageObject | ( |  | ) |

Get the image graphics object if current graphics object represents an image object.

Returns
  Image graphics object. If current graphics object does not represent an image object, this function will return null.

## ◆ GetLayers()

GraphicsObject.GetLayers | ( | layer_tree |  | ) |

Get all the layers which are associated with current graphics object.

Parameters

  [in] | layer_tree | A valid layer tree. All the layer nodes in this layer tree will be enumerated in order to find which are associated with current graphics object.

Returns
  A layer node array which contains all the matched layer node.

## ◆ GetMarkedContent()

GraphicsObject.GetMarkedContent | ( |  | ) |

Get marked content object.

Returns
  A marked content object. If there is any error, this function will return null.

## ◆ GetMatrix()

GraphicsObject.GetMatrix | ( |  | ) |

Get matrix.

Returns
  Matrix value. If there is any error, this function will return a Matrix with all values 0.

## ◆ GetPathObject()

GraphicsObject.GetPathObject | ( |  | ) |

Get the path graphics object if current graphics object represents a path object.

Returns
  Path graphics object. If current graphics object does not represent a path object, this function will return null.

## ◆ GetRect()

GraphicsObject.GetRect | ( |  | ) |

Get the rectangle of current graphics object.

Returns
  Rectangle of current graphics object. If there is any error, this function will return a RectF object with all values 0.

## ◆ GetShadingObject()

GraphicsObject.GetShadingObject | ( |  | ) |

Get the shading graphics object if current graphics object represents a shading object.

Returns
  Shading graphics object. If current graphics object does not represent a shading object, this function will return null.

## ◆ GetStrokeColor()

GraphicsObject.GetStrokeColor | ( |  | ) |

Get the stroke color.

Text graphics object, path graphics object, and form XObject graphics object can have this property.
Function GraphicsObject.GetColorState can be used to get stroke color in other color space, like CMYK color space.

Returns
  Color value, in format 0xAARRGGBB.

## ◆ GetStrokeOpacity()

GraphicsObject.GetStrokeOpacity | ( |  | ) |

Get opacity value for stroke painting operations for paths and glyph outlines.

Returns
  The opacity value. Valid range: 0.0 to 1.0. 0.0 means full transparency and 1.0 means full opaque. If no opacity value can be found, 1 will be returned as default value.

## ◆ GetTextObject()

GraphicsObject.GetTextObject | ( |  | ) |

Get the text graphics object if current graphics object represents a text object.

Returns
  Text graphics object. If current graphics object does not represent a text object, this function will return null.

## ◆ GetType()

GraphicsObject.GetType | ( |  | ) |

Get the type of current graphics object.

Returns
  Graphics object type. Please refer to values starting from GraphicsObject.e_TypeText and this would be one of these values except GraphicsObject.e_TypeAll.

## ◆ HasTransparency()

GraphicsObject.HasTransparency | ( |  | ) |

Check whether current graphics object has transparency or not.

Returns
  true means current graphics object has transparency, while false means not.

## ◆ Release()

GraphicsObject.Release | ( |  | ) |

Release a cloned or newly created PDF graphics object which has not been inserted into any PDF page or other object.

Returns
  None.

## ◆ RemoveClipPath()

GraphicsObject.RemoveClipPath | ( | index |  | ) |

Remove a path clip by index.

Parameters

  [in] | index | Path clip index. Valid range: from 0 to (count-1). count is returned by function GraphicsObject.GetClipPath.

Returns
  true means success, while false means failure.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ RemoveClipTextObject()

GraphicsObject.RemoveClipTextObject | ( | index |  | ) |

Remove a text clip by index for clipping.

Parameters

  [in] | index | Text clip index. Valid range: from 0 to (count-1). count is returned by function GraphicsObject.GetClipTextObjectCount.

Returns
  true means success, while false means failure.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ Rotate()

GraphicsObject.Rotate | ( | angle |  | ) |

Rotate current graphics object from current state with specified angle degree in clockwise.

Parameters

  [in] | angle | Angle degree value, which is used to rotate current graphics object from current state in clockwise. Value range: from 0 to 360. Specially, if the input value is 0 or 360 (which means not to rotate current graphics object), current function will do nothing.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetBlendMode()

GraphicsObject.SetBlendMode | ( | blend_mode |  | ) |

Set the blend mode for transparent imaging model.

Parameters

  [in] | blend_mode | New blend mode. Please refer to values starting from GraphicsObject.e_BlendNormal and this should be one of these values.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetClipRect()

GraphicsObject.SetClipRect | ( | clip_rect |  | ) |

Set clip rectangle.

New clip rectangle will be set with fill mode e_FillModeWinding by default.

Parameters

  [in] | clip_rect | New clip rectangle.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetColorState()

GraphicsObject.SetColorState | ( | color_state |  | ) |

Set color state.

Text graphics object, path graphics object, and form XObject graphics object can have this property. If try to set color state for rest unsupported types, exception e_ErrUnsupported will be thrown.

Parameters

  [in] | color_state | A color state object to be set to current graphics object.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetFillColor()

GraphicsObject.SetFillColor | ( | color |  | ) |

Set the fill color.

Text graphics object, path graphics object, and form XObject graphics object can have color state. If try to set fill color for rest unsupported types, e_ErrUnsupported will be thrown.
For path graphics object, please ensure the fill mode is not e_FillModeNone; otherwise the fill color will not have any effect on the path graphics object. Please refer to functions PathObject.GetFillMode and PathObject.SetFillMode to check and change the fill mode of a path graphics object.
Function GraphicsObject.SetColorState can be used to set fill color in other color space, like CMYK color space.

Parameters

  [in] | color | New color value, in format 0xAARRGGBB.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetFillOpacity()

GraphicsObject.SetFillOpacity | ( | opacity |  | ) |

Set the opacity value for painting operations other than stroking.

Parameters

  [in] | opacity | The new opacity value. Valid range: 0.0 to 1.0. 0.0 means full transparency and 1.0 means full opaque.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetGraphState()

GraphicsObject.SetGraphState | ( | graph_state |  | ) |

Set graph state.

Form XObjet graphics object, path graphics object and text graphics object (whose text mode is TextState.e_ModeStroke, TextState.e_ModeStrokeClip, TextState.e_ModeFillStroke or TextState.e_ModeFillStrokeClip) can have this property. If try to set graph state to rest unsupported types, exception e_ErrUnsupported will be thrown.

Parameters

  [in] | graph_state | New graph state.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetMatrix()

GraphicsObject.SetMatrix | ( | matrix |  | ) |

Set matrix.

Parameters

  [in] | matrix | New matrix value.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetStrokeColor()

GraphicsObject.SetStrokeColor | ( | color |  | ) |

Set the stroke color.

Text graphics object, path graphics object, and form XObject graphics object can have this property. If current graphics object is a text graphics object and the text mode is TextState.e_ModeFill, the stroke color will not have effect on the text graphics object.
If try to set stroke color for rest unsupported types, exception e_ErrUnsupported will be thrown.
Function GraphicsObject.SetColorState can be used to set stroke color in other color space, like CMYK color space.

Parameters

  [in] | color | New color value, in format 0xAARRGGBB.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ SetStrokeOpacity()

GraphicsObject.SetStrokeOpacity | ( | opacity |  | ) |

Set opacity value for stroke painting operations for paths and glyph outlines.

Parameters

  [in] | opacity | The new opacity value. Valid range: 0.0 to 1.0. 0.0 means full transparency and 1.0 means full opaque.

Returns
  None.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## ◆ Transform()

GraphicsObject.Transform | ( | matrix | ,
|  | need_transform_clippath |
| ) |  |

Transform current graphics object.

Parameters

  [in] | matrix | Transform matrix.
  [in] | need_transform_clippath | true means to transform clip path with current graphics object. false means to transform current graphics object only.

Returns
  true means success, while false means failure.

Note
  When this function succeeds, function GraphicsObjects.GenerateContent should be called. Please refer to function GraphicsObjects.GenerateContent for more details.

## Member Data Documentation

## ◆ e_BlendColor

GraphicsObject.e_BlendColor
| static

Creates a color with the hue and saturation of the source color, and the luminosity of the backdrop color.

Here is the formula :

    B(Cb, Cs) = SetLum(Cs, Lum(Cb)).

## ◆ e_BlendColorBurn

GraphicsObject.e_BlendColorBurn
| static

Darkens backdrop color to reflect the source color.

Painting with white produces no changes.
Here is the formula :

             B(Cb, Cs) =
             -1 - min(1, (1 - Cb) / Cs)  if Cs > 0
             -0              if Cs = 0

## ◆ e_BlendColorDodge

GraphicsObject.e_BlendColorDodge
| static

Brightens backdrop color to reflect source colors.

Painting with black produces no changes.
Here is the formula :

             B(Cb, Cs) =
             -min(1, Cb / (1 - Cs))    if Cs < 1
             -1              if Cs = 1

## ◆ e_BlendDarken

GraphicsObject.e_BlendDarken
| static

Select darker one of backdrop and source colors.

Here is the formula :

    B(Cb, Cs) = min(Cb, Cs).

## ◆ e_BlendDifference

GraphicsObject.e_BlendDifference
| static

Subtracts the darker of the two constituent colors from lighter colors.

Here is the formula :

    B(Cb, Cs) = |Cb - Cs|.

## ◆ e_BlendExclusion

GraphicsObject.e_BlendExclusion
| static

Creates a color with the hue of the source color, and the saturation and luminosity of the backdrop color.

Here is the formula :

    B(Cb, Cs) = SetLum(SetSat(Cs, Sat(Cb)), Lum(Cb)).

## ◆ e_BlendHardlight

GraphicsObject.e_BlendHardlight
| static

Multiply or screens colors, depending on source color value.

Here is the formula :

            B(Cb, Cs) =
            -Multiply(Cb, 2 * Cs)    if Cs <= 0.5
            -Screen(Cb, 2 * Cs - 1)  if Cs > 0.5

## ◆ e_BlendHue

GraphicsObject.e_BlendHue
| static

Creates a color with the hue of the source color, and the saturation and luminosity of the backdrop color.

Here is the formula :

    B(Cb, Cs) = SetLum(SetSat(Cs, Sat(Cb)), Lum(Cb)).

## ◆ e_BlendLighten

GraphicsObject.e_BlendLighten
| static

Select lighter one of backdrop and source colors.

Here is the formula :

    B(Cb, Cs) = max(Cb, Cs).

## ◆ e_BlendLuminosity

GraphicsObject.e_BlendLuminosity
| static

Creates a color with the luminosity of the source color, and the hue and saturation of the backdrop color.

Here is the formula :

    B(Cb, Cs) = SetLum(Cb, Lum(Cs)).

## ◆ e_BlendMultiply

GraphicsObject.e_BlendMultiply
| static

Multiply backdrop by source color values.

Here is the formula :

    B(Cb, Cs) = Cb * Cs.

## ◆ e_BlendNormal

GraphicsObject.e_BlendNormal
| static

Enumeration for render blend mode.

Values of this enumeration should be used alone.

Selecting source color and ignoring backdrop color. Here is the formula :

    B(Cb, Cs) = Cs.

## ◆ e_BlendOverlay

GraphicsObject.e_BlendOverlay
| static

Multiply or screens colors, depending on backdrop color value.

Here is the formula :

    B(Cb, Cs) = HardLight(Cs, Cb).

## ◆ e_BlendSaturation

GraphicsObject.e_BlendSaturation
| static

Creates a color with the saturation of the source color, and the hue and luminosity of the backdrop color.

Here is the formula :

    B(Cb, Cs) = SetLum(SetSat(Cb, Sat(Cs)), Lum(Cb)).

## ◆ e_BlendScreen

GraphicsObject.e_BlendScreen
| static

Multiply complements of backdrop by source color values, and then complement the result.

Here is the formula :

    B(Cb, Cs) = 1 - [(1 - Cb) * (1 - Cs)] = Cb + Cs - Cb * Cs.

## ◆ e_BlendSoftlight

GraphicsObject.e_BlendSoftlight
| static

Darkens or lightens colors, depending on source color value.

Here is the formula :

            B(Cb, Cs) =
            -Cb - (1 - 2 * Cs) * Cb * (1 - Cb)    if Cs <= 0.5
            -Cb + (2 * Cs - 1) * (D(Cb) - Cb)    if Cs > 0.5
            where D(x) =
            -((16 * x - 12) * x + 4) * x      if x <= 0.25
            -sqrt(x)                if x > 0.25

## ◆ e_TypeAll

GraphicsObject.e_TypeAll
| static

Enumeration for PDF graphics object type.

Values of this enumeration should be used alone.

Represents all graphics object types, only used as filter.